﻿Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim dt As DataTable = New DataTable("Test")
        Dim dr As DataRow

        ' create test columns
        With dt
            .Columns.Add("colnovaluelist")
            .Columns.Add("coldifferent", GetType(Integer))
            .Columns.Add("colsame", GetType(Integer))
        End With

        ' insert test data
        For i As Integer = 0 To 9
            dr = dt.NewRow()
            dr.Item("colnovaluelist") = "Item" & i
            dr.Item("coldifferent") = i
            dr.Item("colsame") = i
            dt.Rows.Add(dr)
        Next i

        ' bind data to grid
        UltraGrid1.Datasource = dt
    End Sub

    Private Function getArraylist(ByVal intI As Integer) As ArrayList
        Dim alRes As ArrayList = New ArrayList
        Dim objTmp As myObject
        For i As Integer = 0 To intI
            objTmp = New myObject(i, "Item" & i)
            alRes.Add(objTmp)
        Next i
        Return alRes
    End Function

    Private Sub UltraGrid1_InitializeLayout(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles UltraGrid1.InitializeLayout
        ' hide plus signs coming from arraylists
        e.Layout.Override.ExpansionIndicator = ShowExpansionIndicator.Never

        ' attach one value list to whole column
        e.Layout.Bands(0).Columns("colsame").ValueList = getValueList(getArraylist(9))
    End Sub

    Private Sub UltraGrid1_InitializeRow(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.InitializeRowEventArgs) Handles UltraGrid1.InitializeRow
        ' attach different value lists to each row/cell
        e.Row.Cells("coldifferent").ValueList = getValueList(getArraylist(e.Row.Index))
    End Sub

    Private Function getValueList(ByVal alObjects As ArrayList)
        Dim vlstRes As Infragistics.Win.ValueList
        Dim obj As myObject

        vlstRes = New Infragistics.Win.ValueList
        For Each obj In alObjects
            If Not obj Is Nothing Then vlstRes.ValueListItems.Add(obj.ID, obj.Name)
        Next obj

        Return vlstRes
    End Function

    Private Class myObject
        Private mintID As String
        Private mstrName As String

        Public Sub New(ByVal intID As Integer, ByVal strName As String)
            mintID = intID
            mstrName = strName
        End Sub

        Public Property ID As Integer
            Get
                Return mintID
            End Get
            Set(ByVal value As Integer)
                mintID = value
            End Set
        End Property

        Public Property Name() As String
            Get
                Return mstrName
            End Get
            Set(ByVal value As String)
                mstrName = value
            End Set
        End Property
    End Class
End Class
